package rangesearch;

import jdsl.core.api.*;
import jdsl.core.ref.*;
import jdsl.geomobj.api.*;
import jdsl.geomobj.ref.*;

public class LexographicComparator extends AbstractComparator implements Comparator {
    protected GeomTester2D m_tester;

    public LexographicComparator(GeomTester2D tester) {
        m_tester = tester;
    }

    public int compare(Object a, Object b)
        throws ClassCastException {
        Point2D pa = (Point2D) a;
        Point2D pb = (Point2D) b;
        int test1 = m_tester.leftRight(pa, pb);
        int test2 = m_tester.aboveBelow(pa, pb);
        if(test1 == GeomTester2D.LEFT) { 
            return -1;
        } else if(test1 == GeomTester2D.RIGHT) {
            return  1;
        } else if(test2 == GeomTester2D.BELOW) {
            return -1;
        } else if(test2 == GeomTester2D.ABOVE) {
            return  1;
        } else {
            return  0;
        }
    }

    public boolean isComparable(Object a) {
        try {
            Point2D pa = (Point2D) a;
            return true;
        } catch (ClassCastException ex) {
            return false;
        }
    }

}



