package rangesearch.test;

import rangesearch.api.*;
import rangesearch.ref.*;
import rangesearch.*;

import jdsl.core.api.*;
import jdsl.core.ref.*;
import jdsl.geomobj.api.*;
import jdsl.geomobj.ref.*;
import junit.framework.TestCase;

/** A class for testing BruteForceRangeSearchImpl with several
    hand built examples.
 */
public class BruteForceTest extends RangeSearch2DUtil {
    public BruteForceTest(String name) {
        super(name);
    }

    /** Initializes an instance of BruteForceRangeSearch2D with some
	hand picked points and tests these over several hand 
	built query rectangles.
     */
    public void testSquare() {
        GeomTester2D tester = new GeomTester2DImpl();
        RangeSearch2D rsi = new BruteForceRangeSearch2D(tester);
        int coords[] = {
            10, 10,
            10, 20,
            20, 20, 
            20, 10,
            15, 15,
        };
        rsi.initialize(buildPointSequence(coords));
        Rectangle2D r;

        r = buildRect(5, 5, 15, 15);
        checkQuery(rsi, r, "[ (10, 10) (15, 15) ]");

        r = buildRect(10, 5, 15, 15);
        checkQuery(rsi, r, "[ (10, 10) (15, 15) ]");

        r = buildRect(5, 10, 15, 15);
        checkQuery(rsi, r, "[ (10, 10) (15, 15) ]");

        r = buildRect(10, 10, 15, 15);
        checkQuery(rsi, r, "[ (10, 10) (15, 15) ]");

        r = buildRect(5, 5, 10, 10);
        checkQuery(rsi, r, "[ (10, 10) ]");

        r = buildRect(11, 11, 19, 14);
        checkQuery(rsi, r, "[ ]");

        r = buildRect(11, 11, 14, 19);
        checkQuery(rsi, r, "[ ]");

        r = buildRect(5, 5, 9, 9);
        checkQuery(rsi, r, "[ ]");

        r = buildRect(10, 10, 20, 20);
        checkQuery(rsi, r, "[ (10, 10) (10, 20) (15, 15) (20, 10) (20, 20) ]");
    }
}

